c
c plane truss element ************************************** 4/9/1990
c
      program truss
c
c ***************************** D A T A *****************************
c data in 'truss.dat'; f[^ truss.dat Ƃt@Cɍ쐬
c
c     (1) title (a70)       : title = title of a job
c                                     ̃^Cg 70 ȓ
c                                   = 'end' at the end of all jobs
c                                     ׂĂ̍Ō end ̎O
c     (2) node,nel,ee       : node = # of nodes; ߓ_
c               (2i5,f10.0)   nel  = # of elements; vf
c                             ee   = basic Young-s modulus E0
c                                    Ŝ̊{ƂȂ郄O
c     (3) x,z(2f10.0)       : x    = x-coordinate of a node
c                                          x = horizontal to the right
c                                    E̐ߓ_Wl
c                             z    = z-coordinate of a node
c                                          z = vertical downward
c                                    ̐ߓ_Wl
c         need 'node' sets of (3); ꂪɑߓ_sKvɂȂ
c     (4) i,j,re,area       : i,j  = node no. of an element
c                                    vf̍E[ߓ_̐ߓ_ԍ
c              (2i5,2f10.0)   re   = Young-s modulus ratio; E/E0
c                                    ̊{OƂ̔䗦
c                             area = Cross-sectional area
c                                    ̗vf̒fʐ
c         need 'nel' sets of (4); ꂪɑvfsKvɂȂ
c     (5) ndis(i5)          : ndis = # of fixed-displacement(!) B.C.s
c                                    ψʂŒ肷鋫E
c     (6) j,k(2i5)          : j    = node no. of zero displacement B.C.
c                                    ψʂŒ肷ߓ_̔ԍ
c                             k    = displ. component(1=x-dir, 2=z-dir)
c                                    ̐ߓ_ŌŒ肷ψʐ̕
c                                    Ȃ 1, Ȃ 2
c         need 'ndis' sets of (6); ꂪ ndis sKvɂȂ
c     (7) nforc(i5)         : nforc= # of given-force B.C.s
c                                    O͂^鋫E
c     (8) j,k,ff(2i5,f10.0) : j    = node no. of given-force B.C.
c                                    O͂^ߓ_̔ԍ
c                             k    = force component(1=x-dir, 2=z-dir)
c                                    ̐ߓ_ŗ^O͂̕
c                                    Ȃ 1, Ȃ 2
c                             ff   = its value
c                                    ȂEɂāCO͂̒l
c                                    Ȃ牺ɂāCO͂̒l
c         need 'nforc' sets of (8); ꂪ nforc sKvɂȂ
c
c     (1)-(8) ЂƂ̖ɑ΂ZbgŁCZbgłׂĂ悢
c     Ctruss.dat ̍ŏIs͍l߂ end Ƃ
c
c ************************ P R O G R A M ****************************
c
      parameter (mtop=8000)
c ************************* max. for 16-bit PC = 8 x 8000 = 64KB ****
c GȌnꍇɂ́C̏𑝂₹΂悢
c
      implicit real*8 (a-h,o-z)
      character*70 title
      character*3  job,endjob
      common / mem1 / a(mtop)
      common / mem2 / b(mtop)
      common / mem3 / n(mtop)
      common pi
      equivalence (title,job)
      data endjob / 'end' /
c
      pi=4.d0*atan(1.d0)
      open(5,file='truss.dat')
      write(6,200)
c
c one case starts here **********************************************
c
   30 continue
      read(5,500) title
      write(6,600) title
      if( job.eq.endjob ) go to 20
c
c basic data input **************************************************
c
      read(5,400) node,nel,ee
      nn=2*node
      write(6,100) node,nel,ee
c
c address setting ***************************************************
c
      n1=1
      n2=n1+nn*nn
      n3=n2+nn
      nlast1=n3+2*node-1
      n4=n3+nel
      nlast2=n4+nel-1
      if( nlast1.le.mtop.and.nlast2.le.mtop ) go to 10
      write(6,300) nlast1,nlast2,mtop
      go to 20
   10 continue
      m1=1
      m2=m1+nn
c
c real main routine *************************************************
c
      call ctruss ( a(n1),a(n2),a(n3),b(n1),b(n2),b(n3),b(n4),
     *                                   n(m1),n(m2),ee,node,nel,nn )
      go to 30
c
   20 continue
      close (5)
      stop 'End of FEM/plane truss/ program'
c
  100 format(' ','# of nodes =',i5,' :',16x,'# of elements =',i5/
     *       ' ','Young-s modulus (E0) =',1pd15.7/)
  200 format(' ','FEM/plane truss/',52x,'04-09-1990'/)
  300 format(' ','Either nlast1(',i5,') or nlast2(',i5,') is larger',
     *           ' than mtop(',i5,').'/
     *       ' ','Cannot carry out calculation!')
  400 format(2i5,f10.0)
  500 format(a70)
  600 format(/' ',70('-')/' ',a70/' ',70('-'))
      end
c
c real main routine *************************************************
c
      subroutine ctruss ( s,f,x,sr,fr,re,area,ind,nbar,ee,node,nel,nn )
c
      implicit real*8 (a-h,o-z)
      character*1 dir(2)
      dimension s(nn,nn),f(nn),x(2,node),sr(nn,nn),fr(nn)
      dimension re(nel),area(nel),ind(nn),nbar(2,nel),sl(4,4)
      common pi
      data dir / 'x', 'z' /
c
c node data/ element data *******************************************
c
      do 10 i=1,node
      call coord (x(1,i),i)
   10 continue
      write(6,100)
      do 15 i=1,nel
      call nodel (nbar(1,i),re(i),area(i),i)
   15 continue
c
      do 35 i=1,nn
      do 35 j=1,nn
      s(i,j)=0.d0
      sr(i,j)=0.d0
   35 continue
c
c local and global stiffness matrices *******************************
c
      do 20 i=1,nel
      call locals ( x(1,nbar(1,i)),x(1,nbar(2,i)),re(i),area(i),sl )
      do 20 j=1,2
      j0=2*j-1
      jj=2*nbar(j,i)-1
      do 20 k=1,2
      k0=2*k-1
      kk=2*nbar(k,i)-1
      do 20 l=0,1
      do 20 m=0,1
      s(jj+l,kk+m)=s(jj+l,kk+m)+sl(j0+l,k0+m)
   20 continue
      do 25 i=1,nn
      do 25 j=1,nn
      sr(i,j)=s(i,j)
   25 continue
c
c fixed displacement boundary conditions ****************************
c
      read(5,500) ndis
      write(6,200) ndis
      do 30 i=1,ndis
      read(5,500) j,k
      write(6,300) dir(k),j
      m=2*j-2+k
      do 40 l=1,nn
      s(m,l)=0.d0
      s(l,m)=0.d0
   40 continue
      s(m,m)=1.d0
   30 continue
c
c lu decomposition
c
      call ludcmp(s,f,ind,nn)
c
      do 50 i=1,nn
      f(i)=0.d0
   50 continue
c
c force boundary conditions *****************************************
c
      read(5,500) nforc
      write(6,400) nforc
      do 60 i=1,nforc
      read(5,500) j,k,ff
      write(6,600) dir(k),j,ff
      m=2*j-2+k
      f(m)=ff
   60 continue
c
c solve it !! *******************************************************
c
      call lubksb(s,f,ind,nn)
c
c displacement output ***********************************************
c
      write(6,700)
      do 70 i=1,node
      j=2*i-1
      write(6,800) i,f(j)/ee,f(j+1)/ee
   70 continue
c
c tension/extension output
c
      write(6,900)
      do 80 i=1,nel
      i1=2*nbar(1,i)-1
      i2=2*nbar(2,i)-1
      call tendon ( x(1,nbar(1,i)),x(1,nbar(2,i)),re(i),area(i),
     *                                             f(i1),f(i2),ee,i )
   80 continue
c
c reaction forces
c
      write(6,950)
      do 90 i=1,nn
      fr(i)=0.d0
      do 90 j=1,nn
      fr(i)=fr(i)+sr(i,j)*f(j)
   90 continue
      do 95 i=1,node
      j=2*i-1
      write(6,800) i,fr(j),fr(j+1)
   95 continue
c                     ***********************************************
      return
c
  100 format()
  200 format(/' ','# of fixed displacements =',i5)
  300 format(' ',5x,a1,'-component at node #',i5)
  400 format(/' ','# of given forces        =',i5)
  500 format(2i5,f10.0)
  600 format(' ',5x,a1,'-component at node #',i5,' : (value=',
     *       1pd15.7,' )')
  700 format(/' ','----- RESULTS OUTPUT -----'/
     *        ' ','Displacement:'/' ','  Node',7x,'x-dir',10x,'z-dir')
  800 format(' ',i5,2x,1p2d15.7)
  900 format(/' ','Tension/Extension:'/' ','Element',4x,'Tension',8x,
     *            'Extension')
  950 format(/' ','Reaction (or Applied) forces:'/
     *        ' ','  Node',7x,'x-dir',10x,'z-dir')
      end
c
c input node no. and its coordinates ********************************
c
      subroutine coord (x,node)
c
      implicit real*8 (a-h,o-z)
      dimension x(2)
c
      read(5,100) x(1),x(2)
      write(6,200) node,x(1),x(2)
      return
c
  100 format(2f10.0)
  200 format(' ','Node no.',i5,' :  x=',1pd15.7,'  z=',d15.7)
      end
c
c input node no. of one element *************************************
c
      subroutine nodel (nbar,re,area,nel)
      implicit real*8 (a-h,o-z)
c
      dimension nbar(2)
      read(5,100) nbar(1),nbar(2),re,area
      write(6,200) nel,nbar(1),nbar(2),re,area
      return
c
  100 format(2i5,2f10.0)
  200 format(' ','Elmt no.',i5,' [',i5,' -',i5,' ]  : E/E0 =',
     *           1pd15.7,' : Area =',d15.7)
      end
c
c form local stiffness matrix ***************************************
c
      subroutine locals ( x1,x2,re,area,sl )
c
      implicit real*8 (a-h,o-z)
      common pi
      dimension x1(2),x2(2),sl(4,4)
c
      thx=x2(1)-x1(1)
      thy=x1(2)-x2(2)
      if( abs(thx).le.1.d-36 ) then
          th=thy*pi/2.d0/abs(thy)
      else
          th=atan(thy/thx)
          if( thx.lt.0.d0 ) th=pi+th
      end if
      ct=cos(th)
      st=sin(th)
      tlen=sqrt(thx*thx+thy*thy)
c
      sl(1,1)=ct*ct
      sl(1,2)=-st*ct
      sl(1,3)=-ct*ct
      sl(1,4)=st*ct
      sl(2,2)=st*st
      sl(2,3)=st*ct
      sl(2,4)=-st*st
      sl(3,3)=ct*ct
      sl(3,4)=-st*ct
      sl(4,4)=st*st
c
      do 10 i=1,4
      do 10 j=i,4
      sl(i,j)=sl(i,j)*re*area/tlen
   10 continue
c
      do 20 i=1,3
      do 20 j=i+1,4
      sl(j,i)=sl(i,j)
   20 continue
c
      return
      end
c
c tension/extension calculation *************************************
c
      subroutine tendon ( x1,x2,re,area,d1,d2,ee,iel )
c
      implicit real*8 (a-h,o-z)
      common pi
      dimension x1(2),x2(2),d1(2),d2(2)
c
      thx=x2(1)-x1(1)
      thy=x1(2)-x2(2)
      if( abs(thx).le.1.d-36 ) then
          th=thy*pi/2.d0/abs(thy)
      else
          th=atan(thy/thx)
          if( thx.lt.0.d0 ) th=pi+th
      end if
      tlen=sqrt(thx*thx+thy*thy)
c
      ext=(cos(th)*(d2(1)-d1(1))+sin(th)*(d1(2)-d2(2)))/tlen
      ten=re*area*ext
      ext=ext/ee
c
      write(6,100) iel,ten,ext
c
      return
c
  100 format(' ',i5,2x,1p2d15.7)
      end
c
c  from "NUMERICAL RECIPES" by W.H.Press et al. *********************
c  for LU decomposition of matrix a(n,n)
c
      subroutine ludcmp (a,w,ind,n)
c
      implicit real*8 (a-h,o-z)
      dimension a(n,n),w(n),ind(n)
c                      w : working area
      data tiny / 1.d-20 /
c
      do 20 i=1,n
      aamax=0.d0
      do 10 j=1,n
      if( abs(a(i,j)).gt.aamax ) aamax=abs(a(i,j))
   10 continue
      if( aamax.eq.0.d0 ) stop 'ERROR'
      w(i)=1.d0/aamax
   20 continue
      do 90 j=1,n
      do 40 i=1,j-1
      sum=a(i,j)
      do 30 k=1,i-1
      sum=sum-a(i,k)*a(k,j)
   30 continue
      a(i,j)=sum
   40 continue
      aamax=0.d0
      do 60 i=j,n
      sum=a(i,j)
      do 50 k=1,j-1
      sum=sum-a(i,k)*a(k,j)
   50 continue
      a(i,j)=sum
      dum=w(i)*abs(sum)
      if( dum.ge.aamax ) then
        imax=i
        aamax=dum
      endif
   60 continue
      if( j.ne.imax ) then
        do 70 k=1,n
        dum=a(imax,k)
        a(imax,k)=a(j,k)
        a(j,k)=dum
   70   continue
        w(imax)=w(j)
      endif
      ind(j)=imax
      if( a(j,j).eq.0.d0 ) a(j,j)=tiny
      if( j.ne.n ) then
        dum=1.d0/a(j,j)
        do 80 i=j+1,n
        a(i,j)=a(i,j)*dum
   80   continue
      endif
   90 continue
      return
      end
c
c  from "NUMERICAL RECIPES" by W.H.Press et al. *********************
c
c  to solve linear algebraic equation ax=b by LU decomposition
c     "x" will be stored in "b"
c
      subroutine lubksb (a,b,ind,n)
c
      implicit real*8 (a-h,o-z)
      dimension a(n,n),b(n),ind(n)
      ii=0
      do 20 i=1,n
      ll=ind(i)
      sum=b(ll)
      b(ll)=b(i)
      if( ii.ne.0 ) then
        do 10 j=ii,i-1
        sum=sum-a(i,j)*b(j)
   10   continue
      else if( sum.ne.0.d0 ) then
        ii=i
      endif
      b(i)=sum
   20 continue
      do 40 i=n,1,-1
      sum=b(i)
      if( i.lt.n ) then
        do 30 j=i+1,n
        sum=sum-a(i,j)*b(j)
   30   continue
      endif
      b(i)=sum/a(i,i)
   40 continue
      return
      end
